/**********************************************************
 * Grooves: Gtk+ iTunes Music Store client
 **********************************************************
 * By: Aaron Conole <conole@comcast.net>
 * Copyright (C) 2005 Aaron Conole
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "grooves.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_dAboutDialog (struct vAboutWindowInfoStruct *pAboutWindow)
{
  GtkWidget *dAboutDialog = pAboutWindow->dAboutDialog;
  GtkWidget *dialog_vbox1 = pAboutWindow->dialog_vbox1;
  GtkWidget *label1 = pAboutWindow->label1;
  GtkWidget *dialog_action_area1 = pAboutWindow->dialog_action_area1;
  GtkWidget *closebutton1 = pAboutWindow->closebutton1;

  dAboutDialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dAboutDialog), _("About"));
  gtk_window_set_resizable (GTK_WINDOW (dAboutDialog), FALSE);
  gtk_window_set_type_hint (GTK_WINDOW (dAboutDialog), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dAboutDialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  label1 = gtk_label_new (_("\nGrooves\nGTK+ iTunes Store\nBased on SharpMusique 1.0 and patches\n\nGTK+ iTunes Store written by: Aaron Conole\n\nSharpMusique written by: John Lech Johansen\n\nVersion: 0.0.1"));
  gtk_widget_show (label1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), label1, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_CENTER);

  dialog_action_area1 = GTK_DIALOG (dAboutDialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  closebutton1 = gtk_button_new_from_stock ("gtk-close");
  gtk_widget_show (closebutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dAboutDialog), closebutton1, GTK_RESPONSE_CLOSE);
  GTK_WIDGET_SET_FLAGS (closebutton1, GTK_CAN_DEFAULT);
/*  g_signal_connect((gpointer) closebutton1,
                   "activate",
                   G_CALLBACK(close_about_window),
                   NULL);
*/
  gtk_signal_connect_object(GTK_OBJECT (closebutton1), "clicked", gtk_widget_destroy, GTK_OBJECT(dAboutDialog));
  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dAboutDialog, dAboutDialog, "dAboutDialog");
  GLADE_HOOKUP_OBJECT_NO_REF (dAboutDialog, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT (dAboutDialog, label1, "label1");
  GLADE_HOOKUP_OBJECT_NO_REF (dAboutDialog, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (dAboutDialog, closebutton1, "closebutton1");

  return dAboutDialog;
}
