#ifndef __GTK_ITUNES_H
#define __GTK_ITUNES_H

#include <gtk/gtk.h>
#include "storelib.h"
#include "preferences.h" //include access to prefs.

enum 
{
    COL_TITLE = 0,
    COL_ARTIST,
    COL_ALBUM,
    COL_TIME,
    COL_PRICE,
    NUM_COLS
};

struct vPrefsWindowInfoStruct
{
  GtkWidget *dPrefsDialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox1;
  GtkWidget *vbox2;
  GtkWidget *hbox1;
  GtkWidget *songdirlabel;
  GtkWidget *entry1;
  GtkWidget *hbox2;
  GtkWidget *prefslabel2;
  GtkWidget *entry2;
  GtkWidget *vbox3;
  GtkWidget *entry3;
  GtkWidget *hseparator1;
  GtkWidget *checkbutton1;
  GtkWidget *checkbutton2;
  GtkWidget *dialog_action_area4;
  GtkWidget *cancelbutton2;
  GtkWidget *applybutton1;
  GtkWidget *okbutton3;
};

struct vLoginWindowInfoStruct
{
  GtkWidget *dLoginDialog;
  GtkWidget *dialog_vbox2;
  GtkWidget *vbox4;
  GtkWidget *hbox5;
  GtkWidget *label4;
  GtkWidget *username_entry;
  GtkWidget *hbox6;
  GtkWidget *label5;
  GtkWidget *password_entry;
  GtkWidget *dialog_action_area2;
  GtkWidget *cancelbutton1;
  GtkWidget *okbutton1;
};

struct vAboutWindowInfoStruct
{
  GtkWidget *dAboutDialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *label1;
  GtkWidget *dialog_action_area1;
  GtkWidget *closebutton1;
};

struct vBuyWindowInfoStruct
{
  GtkWidget *dPurchaseDialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *title;
  GtkWidget *artist;
  GtkWidget *album;
  GtkWidget *price;
  GtkWidget *dialog_action_area1;
  GtkWidget *button1;
  GtkWidget *purchase;
};

struct vAlertWindowInfoStruct
{
    //nothing here now...
};

struct vMainWindowInfoStruct
{
  GtkWidget *wMainWindow;
  GtkWidget *vbox2;
  GtkWidget *alignment1;
  GtkWidget *menubar1;
  GtkWidget *menuFile;
  GtkWidget *menuFile_menu;
  GtkWidget *menuQuit;
  GtkWidget *menuEdit;
  GtkWidget *menuEdit_menu;
  GtkWidget *menuPreferences;
  GtkWidget *menuitem3;
  GtkWidget *menuAccount;
  GtkWidget *menuAccount_menu;
  GtkWidget *menuLogin;
  GtkWidget *menuSignup;
  GtkWidget *separator1;
  GtkWidget *menuRedownload;
  GtkWidget *separator2;
  GtkWidget *menuRedeem;
  GtkWidget *menuGCRedeem;
  GtkWidget *menuSong;
  GtkWidget *menuSong_menu;
  GtkWidget *menuPreview;
  GtkWidget *menuPurchase;
  GtkWidget *menuitem4;
  GtkWidget *menuitem4_menu;
  GtkWidget *about1;
  GtkWidget *vpaned1;
  GtkWidget *hbox2;
  GtkWidget *entry1;
  GtkWidget *searchButton;
  GtkWidget *vbox3;
  GtkWidget *eventbox1;
  GtkWidget *scrolledwindow1;
  GtkWidget *statusbar1;
  GtkAccelGroup *accel_group;

    GtkWidget *treeview1;
    GtkCellRenderer *renderer;
    GtkListStore *pTestStore;
    GtkTreeIter  iter;

//    struct vRedeemWindowInfoStruct _redeemwin;
    struct vPrefsWindowInfoStruct  _prefswin;
    struct vLoginWindowInfoStruct  _loginwin;
    struct vAboutWindowInfoStruct  _aboutwin;
    struct vBuyWindowInfoStruct    _buywin;
   
};

int initFromEnv();
int doCheckPrefsLocations();
int makePrefsLocations();
int fGetPrefsFile(char **ppFilenameBuf);
int fGetTempFile(char **ppFilenameBuf, char *pTempFilename);

/*GROOVES window interface*/
int fShowMainWindow(struct uGroovesSession *pSession);
int fShowSessionLoginWindow(struct uGroovesSession *pSession);
int fShowSessionPreferencesWindow(struct uGroovesSession *pSession);
int fWritePrefsToFile(struct uGroovesSession *pSession, char *pFilename);
int fQuit();

/*GROOVES preferency goodness*/
int fApplyNewSessionSettings(struct uGroovesSession *pSession,
			     struct GroovesPrefBlob rBlob,
			     int do_reset_conn);

#define DEFPROTO "http"
#define DEFHOST "phobos.apple.com"
#define STORE "storebag.xml.gz"
extern char *pHomebaseAddr;
extern char *pHomeDir;

#endif /*__GTK_ITUNES_H*/
