/**********************************************************
 * Grooves: Gtk+ iTunes Music Store client
 **********************************************************
 * By: Aaron Conole <conole@comcast.net>
 * Copyright (C) 2005 Aaron Conole
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "support.h"

#include "grooves.h"
#include "storelib.h"
#include "grooves_interface.h"

struct vAboutWindowInfoStruct *
getAboutDialog()
{
    return &rMainStruct._aboutwin;
}

struct vPrefsWindowInfoStruct *
getPrefsDialog()
{
    return &rMainStruct._prefswin;
}

struct vBuyWindowInfoStruct *
getPurchaseDialog()
{
    return &rMainStruct._buywin;
}

/*struct vRedeemWindowInfoStruct *
getRedeemDialog()
{
    return &rMainStruct._redeemwin;
}
*/
struct vLoginWindowInfoStruct *
getLoginDialog()
{
    return &rMainStruct._loginwin;
}

int fShowMainWindow(struct uGroovesSession *pSession)
{
    GtkWidget *wMainWindow = 0;
    wMainWindow = create_wMainWindow (&rMainStruct);
    doStartTreeOff(rMainStruct);
    gtk_widget_show_all (wMainWindow);
    g_signal_connect( wMainWindow, "delete_event", fDoQuit,
		      NULL ); //dirty

    return 0;
}

int fShowSessionLoginWindow(struct uGroovesSession *pSession)
{
    GtkWidget *dLoginDialog;
    struct vLoginWindowInfoStruct *pLoginDialog = getLoginDialog();
    dLoginDialog = create_dLoginDialog (pLoginDialog);

    if(pSession->_pUserName)
        gtk_entry_set_text (GTK_ENTRY (pLoginDialog->username_entry), 
                            _(pSession->_pUserName));

    if(pSession->_pPassWord)
        gtk_entry_set_text (GTK_ENTRY (pLoginDialog->password_entry), 
                            _(pSession->_pPassWord));

    gtk_widget_show (dLoginDialog);

    return 0;
}

int fShowSessionPreferencesWindow(struct uGroovesSession *pSession)
{
    GtkWidget *dPreferencesDialog;
    struct vPrefsWindowInfoStruct *pPrefsDialog = getPrefsDialog();
    dPreferencesDialog = create_dPrefsDialog (pPrefsDialog);

    if(pSession->_currentPreferences._autologin)
      gtk_toggle_button_set_active(
				GTK_TOGGLE_BUTTON(pPrefsDialog->checkbutton1),
				TRUE);

    if(pSession->_currentPreferences._rememberpw)
      gtk_toggle_button_set_active(
				GTK_TOGGLE_BUTTON(pPrefsDialog->checkbutton2),
				TRUE);
    
    if(pSession->_currentPreferences._pSongsDir)
      gtk_entry_set_text(GTK_ENTRY(pPrefsDialog->entry1),
			 _(pSession->_currentPreferences._pSongsDir));
    else
      gtk_entry_set_text(GTK_ENTRY(pPrefsDialog->entry1),
			 _(pHomeDir));

    if(pSession->_currentPreferences._pBaseURL)
      gtk_entry_set_text(GTK_ENTRY(pPrefsDialog->entry2),
			 _(pSession->_currentPreferences._pBaseURL));
    else
      gtk_entry_set_text(GTK_ENTRY(pPrefsDialog->entry2),
			 _("http://grooves.sourceforge.net/grooves-resource"));

    gtk_widget_show (dPreferencesDialog);

    return 0;
}
