/**********************************************************
 * Grooves: Gtk+ iTunes Music Store client
 **********************************************************
 * By: Aaron Conole <conole@comcast.net>
 * Copyright (C) 2005 Aaron Conole
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "grooves.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)



GtkWidget*
create_dLoginDialog (struct vLoginWindowInfoStruct *pLoginWindow)
{
    GtkWidget *dLoginDialog = 0; 
    GtkWidget *dialog_vbox2 = 0; 
    GtkWidget *vbox4 = 0; 
    GtkWidget *hbox5 = 0; 
    GtkWidget *label4 = 0; 
    GtkWidget *unentry = 0; 
    GtkWidget *hbox6 = 0; 
    GtkWidget *label5 = 0; 
    GtkWidget *password_entry = 0; 
    GtkWidget *dialog_action_area2 = 0; 
    GtkWidget *cancelbutton1 = 0; 
    GtkWidget *okbutton1 = 0; 

  dLoginDialog = gtk_dialog_new ();
  gtk_window_set_title (GTK_WINDOW (dLoginDialog), _("Login"));
  gtk_window_set_modal (GTK_WINDOW (dLoginDialog), TRUE);
  gtk_window_set_resizable (GTK_WINDOW (dLoginDialog), FALSE);
  gtk_window_set_type_hint (GTK_WINDOW (dLoginDialog), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox2 = GTK_DIALOG (dLoginDialog)->vbox;
  gtk_widget_show (dialog_vbox2);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox4);
  gtk_box_pack_start (GTK_BOX (dialog_vbox2), vbox4, TRUE, TRUE, 0);

  hbox5 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox5);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox5, TRUE, TRUE, 0);

  label4 = gtk_label_new (_("Username:"));
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox5), label4, FALSE, FALSE, 0);

  unentry = gtk_entry_new ();
  gtk_widget_show (unentry);
  gtk_box_pack_start (GTK_BOX (hbox5), unentry, TRUE, TRUE, 0);

  hbox6 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox6);
  gtk_box_pack_start (GTK_BOX (vbox4), hbox6, TRUE, TRUE, 0);

  label5 = gtk_label_new (_("Password:"));
  gtk_widget_show (label5);
  gtk_box_pack_start (GTK_BOX (hbox6), label5, FALSE, FALSE, 0);

  password_entry = gtk_entry_new ();
  gtk_widget_show (password_entry);
  gtk_box_pack_start (GTK_BOX (hbox6), password_entry, TRUE, TRUE, 0);

  dialog_action_area2 = GTK_DIALOG (dLoginDialog)->action_area;
  gtk_widget_show (dialog_action_area2);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area2), GTK_BUTTONBOX_END);

  cancelbutton1 = gtk_button_new_from_stock ("gtk-cancel");
  gtk_widget_show (cancelbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dLoginDialog), cancelbutton1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (cancelbutton1, GTK_CAN_DEFAULT);
  gtk_signal_connect_object(GTK_OBJECT (cancelbutton1), "clicked", gtk_widget_destroy, GTK_OBJECT(dLoginDialog));

  okbutton1 = gtk_button_new_from_stock ("gtk-ok");
  gtk_widget_show (okbutton1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dLoginDialog), okbutton1, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (okbutton1, GTK_CAN_DEFAULT);
  gtk_signal_connect_object(GTK_OBJECT(okbutton1), "clicked", fDoLoginWindowOk, GTK_OBJECT(dLoginDialog));

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dLoginDialog, dLoginDialog, "dLoginDialog");
  GLADE_HOOKUP_OBJECT_NO_REF (dLoginDialog, dialog_vbox2, "dialog_vbox2");
  GLADE_HOOKUP_OBJECT (dLoginDialog, vbox4, "vbox4");
  GLADE_HOOKUP_OBJECT (dLoginDialog, hbox5, "hbox5");
  GLADE_HOOKUP_OBJECT (dLoginDialog, label4, "label4");
//  GLADE_HOOKUP_OBJECT (dLoginDialog, username_entry, "username_entry");
  GLADE_HOOKUP_OBJECT (dLoginDialog, hbox6, "hbox6");
  GLADE_HOOKUP_OBJECT (dLoginDialog, label5, "label5");
//  GLADE_HOOKUP_OBJECT (dLoginDialog, password_entry, "password_entry");
  GLADE_HOOKUP_OBJECT_NO_REF (dLoginDialog, dialog_action_area2, "dialog_action_area2");
  GLADE_HOOKUP_OBJECT (dLoginDialog, cancelbutton1, "cancelbutton1");
  GLADE_HOOKUP_OBJECT (dLoginDialog, okbutton1, "okbutton1");

  pLoginWindow->okbutton1 = okbutton1;
  pLoginWindow->cancelbutton1 = cancelbutton1;
  pLoginWindow->dialog_action_area2 = dialog_action_area2;
  pLoginWindow->password_entry = password_entry;
  pLoginWindow->label5 = label5;
  pLoginWindow->hbox6 = hbox6;
  pLoginWindow->username_entry = unentry;
  pLoginWindow->label4 = label4;
  pLoginWindow->hbox5 = hbox5;
  pLoginWindow->vbox4 = vbox4;
  pLoginWindow->dialog_vbox2 = dialog_vbox2;
  pLoginWindow->dLoginDialog = dLoginDialog;

  return dLoginDialog;
}
