/**********************************************************
 * Grooves: Gtk+ iTunes Music Store client
 **********************************************************
 * By: Aaron Conole <conole@comcast.net>
 * Copyright (C) 2005 Aaron Conole
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include "grooves.h"

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  g_object_set_data_full (G_OBJECT (component), name, \
    gtk_widget_ref (widget), (GDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  g_object_set_data (G_OBJECT (component), name, widget)

GtkWidget*
create_dRedeemDialog (void)
{
  GtkWidget *dRedeemDialog;
  GtkWidget *dialog_vbox1;
  GtkWidget *table1;
  GtkWidget *label;
  GtkWidget *entry;
  GtkWidget *dialog_action_area1;
  GtkWidget *button1;
  GtkWidget *button2;

  dRedeemDialog = gtk_dialog_new ();
  gtk_window_set_default_size (GTK_WINDOW (dRedeemDialog), 230, 95);
  gtk_window_set_type_hint (GTK_WINDOW (dRedeemDialog), GDK_WINDOW_TYPE_HINT_DIALOG);

  dialog_vbox1 = GTK_DIALOG (dRedeemDialog)->vbox;
  gtk_widget_show (dialog_vbox1);

  table1 = gtk_table_new (1, 2, FALSE);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), table1, TRUE, TRUE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (table1), 5);
  gtk_table_set_row_spacings (GTK_TABLE (table1), 5);
  gtk_table_set_col_spacings (GTK_TABLE (table1), 5);

  label = gtk_label_new ("");
  gtk_widget_show (label);
  gtk_table_attach (GTK_TABLE (table1), label, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label), 0, 0.5);

  entry = gtk_entry_new ();
  gtk_widget_show (entry);
  gtk_table_attach (GTK_TABLE (table1), entry, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_entry_set_activates_default (GTK_ENTRY (entry), TRUE);

  dialog_action_area1 = GTK_DIALOG (dRedeemDialog)->action_area;
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);

  button1 = gtk_button_new_with_mnemonic (_("Cancel"));
  gtk_widget_show (button1);
  gtk_dialog_add_action_widget (GTK_DIALOG (dRedeemDialog), button1, GTK_RESPONSE_CANCEL);
  GTK_WIDGET_SET_FLAGS (button1, GTK_CAN_DEFAULT);

  button2 = gtk_button_new_with_mnemonic (_("Redeem"));
  gtk_widget_show (button2);
  gtk_dialog_add_action_widget (GTK_DIALOG (dRedeemDialog), button2, GTK_RESPONSE_OK);
  GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (dRedeemDialog, dRedeemDialog, "dRedeemDialog");
  GLADE_HOOKUP_OBJECT_NO_REF (dRedeemDialog, dialog_vbox1, "dialog_vbox1");
  GLADE_HOOKUP_OBJECT (dRedeemDialog, table1, "table1");
  GLADE_HOOKUP_OBJECT (dRedeemDialog, label, "label");
  GLADE_HOOKUP_OBJECT (dRedeemDialog, entry, "entry");
  GLADE_HOOKUP_OBJECT_NO_REF (dRedeemDialog, dialog_action_area1, "dialog_action_area1");
  GLADE_HOOKUP_OBJECT (dRedeemDialog, button1, "button1");
  GLADE_HOOKUP_OBJECT (dRedeemDialog, button2, "button2");

  gtk_widget_grab_focus (entry);
  gtk_widget_grab_default (button2);
  return dRedeemDialog;
}
