/**********************************************************
 * Grooves: Gtk+ iTunes Music Store client
 **********************************************************
 * By: Aaron Conole <conole@comcast.net>
 * Copyright (C) 2005 Aaron Conole
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 */

#include "storelib.h"
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

int fReadLineBufFromFile(int fd, char *pBuf, int len)
{
    char c = 0;
    int count = 0;
    int done = 0;
    int result = 0;

    while((!done) && 
          (count < len))
    {
        result = read(fd, &c, 1);

        if(result < 0)
            return result;

        if(result == 0)
        {
            if(count == 0)
            {
                return 0;
            }
            else
            {
                return count;
            }
        }

        *pBuf = c;
        pBuf++;
        count++;

        if(c == '\n')
            done = 1;
    }
    
    *pBuf = 0;
    
    return count;
}

int fOpenFileForReading(char *pFilename, int flags)
{
    int fd = open(pFilename, O_RDONLY | O_CREAT | flags, 0644);

    if(fd < 0)
    {
        DEBUG_PRINT(("::fOpenFileForReading([%s], [%d]) = %d\n",
               pFilename,
               flags,
               fd));
    }
    
    return fd;
}

int fOpenFileForWriting(char *pFilename, int flags)
{
    int fd = open(pFilename, O_WRONLY | O_CREAT | flags, 0644);
    
    if(fd < 0)
    {
        DEBUG_PRINT(("::fOpenFileForWriting([%s], [%d]) = %d\n",
               pFilename,
               flags,
               fd));
    }
    
    return fd;
}

int fWriteBufToFile(char *pFilename, char *pBufToWrite, int len)
{
    int fd = fOpenFileForWriting(pFilename, O_TRUNC);

    int result = write(fd, pBufToWrite, len);

    if(result < 0)
    {
        DEBUG_PRINT(("::fWriteBufToFile([%s] [..] [%d]) = %d\n",
               pFilename,
               len,
               result));
        return -1;
    }
    
    return 0;
}
